<?php

class CodeTask extends Threaded {

    protected $result = [];
    protected $completed = false;

    public function run() {

        $util = $this->worker->getUtil();

        while (count($this->result) < BUFFER_SIZE_BEFORE_RELEASING_TASK) {
        //for($i = 0; $i < BUFFER_SIZE_BEFORE_RELEASING_TASK; $i++){
           
            $code = $util->generateCode(CODE_LENGTH, CODE_CHARSET);
            
            if (BADWORD_CHECK) {
                
                if ($util->isBadword($code)) {

                    continue;
                }
            }

            if (ENTROPY_CHECK) {

                if (!$util->isWithinEntropyThreshold($code, ENTROPY_LOWER_THRESHOLD, ENTROPY_UPPER_THRESHOLD)) {

                    continue;
                }
            }

            $this->result[] = $code;
        }

        $this->completed = true;
    }

    public function isCompleted() {
        return $this->completed;
    }

    public function getResult() {
        return $this->result;
    }

}
