<?php

const NUMBER_OF_CODES = 50000000;
const CODE_CHARSET = '1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ';                    // You may want to exclude I J L O Q U and/or similar ambiguous characters to avoid confusion when entering these codes manually is required. This will also reduce the number of bad words that need to be checked for.
const CODE_LENGTH = 10;                                                         // Shorter codes might mean that less bad words need to be checked.

const BADWORD_CHECK = true;                                                     // Checks if the code contains a bad word listed in dictionary provided. Depending on the number of entries this will dramatically reduce the throughput.
const BADWORD_DICT = "dict/en_google_badwords.txt";                             // Plain text list of bad words. Numbers in code will be treated like: str_replace(array('1', '2', '3', '4', '5', '6', '7', '8', '9', '0'), array('I', 'Z', 'E', 'A', 'S', 'G', 'T', 'B', 'G', 'O'))

const ENTROPY_CHECK = true;                                                     // Avoids character repetitions in code. https://en.wikipedia.org/wiki/Diversity_index#Shannon_index
const ENTROPY_LOWER_THRESHOLD = 2.2;                                            // ABCD = 2; ABABABABAB = 1; AAAAABCDEF = 2.16; AAAABCDEFG = 2.52
const ENTROPY_UPPER_THRESHOLD = 10.0;                                           // ABCDEFGHIJKLMNOP = 4; you can play around here: http://www.shannonentropy.netmark.pl/

const LOGGING_ENABLED = true;

const DB_DELETE_ON_START = true;                                                // Wipes all previous entries on start
const DB_UNIQUE_CODE_CHECK = true;                                              // Outputs only unqiue codes. Requires DB_DELETE_ON_START = true if changed. 
const DB_CODE_COLUMN_NAME = 'code';
const DB_PATH = 'out/codes.db';
const DB_TABLE = 'data';

const NUMBER_OF_WORKERS_IN_POOL = 4;                                            // Play around. Optimum on my i7 octacore was 4
const NUMBER_OF_CONCURRENT_TASKS = NUMBER_OF_WORKERS_IN_POOL + 1;               // Number of worker objects that will be kept instantiated
const BUFFER_SIZE_BEFORE_RELEASING_TASK = 50000;                                // Number of codes a local worker generates before merging them to the write buffer
const BUFFER_SIZE_BEFORE_SENDING_TO_DB = 250000;                                // Number of codes the global write buffer holds before the codes are sent to the database. Lesser but bigger db inserts are usually faster. 
const BUFFER_SIZE_BEFORE_REDUCING_TASKS = BUFFER_SIZE_BEFORE_SENDING_TO_DB * 4; // Experimental. This parameter will reduce the number of workers in case codes cannot be written fast enough to DB. Expected to be useful for long-running inserts into hugh unique-indexed column. 

