<?php

class Database {

    protected $db;

    function __construct() {

        if (file_exists(DB_PATH) && DB_DELETE_ON_START) {

            file_put_contents(DB_PATH, '');
        }

        $this->db = new SQLite3(DB_PATH);

        if (DB_UNIQUE_CODE_CHECK) {

            $this->db->exec("CREATE TABLE IF NOT EXISTS " . DB_TABLE . "(
                    id INTEGER PRIMARY KEY AUTOINCREMENT,
                    code TEXT UNIQUE
                    )");
        } else {

            $this->db->exec("CREATE TABLE IF NOT EXISTS " . DB_TABLE . "(
                    id INTEGER PRIMARY KEY AUTOINCREMENT,
                    code TEXT
                    )");
        }
    }

    function write(array $buffer) {

        if (empty($buffer)) {

            return;
        }

        $query = "INSERT OR IGNORE INTO " . DB_TABLE . " (" . DB_CODE_COLUMN_NAME . ") VALUES ('" . implode("'), ('", $buffer) . "')";

        $this->db->exec($query) ?: Logger::log('Error: ' . $this->db->lastErrorMsg());
    }

    function count() {

        $result = $this->db->query("SELECT COUNT(*) FROM " . DB_TABLE);
        $count = $result->fetchArray();

        return $count[0];
    }

}
